# Fast constant-time GCD full-width implementation - Integer Case

This is a full width hardware implementation of Modular Inverse using Constant time GCD described in https://eprint.iacr.org/2019/266.pdf.

The design is generic and currently verified for primes (2^255 - 19) and  (2^434 - 183) .

When integrated with the applications the design expects to use the modular multiplication and reduction unit from the application.

Note: For testing purpose fast_gcd module is implemented in which non-optimized multiplication and reduction is used. 

For choosing between 255-bit and 434-bit design uncomment the appropriate constants from the file 'gcd_pkg.vhd'. The default is set to 255-bit design.

User defined widths can be configured in 'gcd_pkg.vhd', appropriate constants needs to be calculated. The calculations of the comments are defined in the comments in 'gcd_pkg.vhd' file. 



- 'rtl' - consists of design files
- 'tb' - consists of testbenches for each case

