----------------------------------------------------------------------------------
-- This file is a add module which can infer dsp

-- Copyright (C) 2021
-- Authors: Sanjay Deshpande <sanjay.deshpande@yale.edu>
          
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software Foundation,
-- Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity add is
    PORT(
         clk : in STD_LOGIC;
           CONCAT : in STD_LOGIC_VECTOR (47 downto 0);
           C : in STD_LOGIC_VECTOR (47 downto 0);
           p : out STD_LOGIC_VECTOR (47 downto 0);
           CARRYIN : in STD_LOGIC  
        );
    attribute use_dsp : string;
    attribute use_dsp of add : entity is "yes";
end add;

architecture Behavioral of add is
signal CONCAT_reg : std_logic_vector(47 downto 0);
signal C_reg : std_logic_vector(47 downto 0);
signal CARRYIN_reg : std_logic;
begin

process(clk)
begin
    if rising_edge(clk) then
      CONCAT_reg <= CONCAT;   
      C_reg <= C;   
      CARRYIN_reg <= CARRYIN;   
    end if;
end process;

p <= CONCAT_reg + C_reg + CARRYIN_reg;

end Behavioral;
