----------------------------------------------------------------------------------
-- This file is a mul_and_acc module which can infer dsp

-- Copyright (C) 2021
-- Authors: Sanjay Deshpande <sanjay.deshpande@yale.edu>
          
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software Foundation,
-- Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_unsigned.ALL;

entity mul_and_acc is
    Port ( 
           clk : in STD_LOGIC;
           a : in STD_LOGIC_VECTOR (18-1 downto 0);
           b : in STD_LOGIC_VECTOR (18-1 downto 0);
           c : in STD_LOGIC_VECTOR (47 downto 0);
           p : out STD_LOGIC_VECTOR (47 downto 0)   
           );
    attribute use_dsp : string;
    attribute use_dsp of mul_and_acc : entity is "yes";
end mul_and_acc;

architecture Behavioral of mul_and_acc is
signal a_reg, b_reg : std_logic_vector(18-1 downto 0);

signal c_reg : std_logic_vector(47 downto 0);

signal a_mul_b: std_logic_vector(18*2 - 1 downto 0);

begin


process(clk)
begin
    if rising_edge(Clk) then
        a_mul_b <= a*b;
        c_reg <= c;
    end if;
end process;


p <= c_reg + a_mul_b;


end Behavioral;
